package de.telefonbuch.model;

import java.sql.*;

public class Datenbank {

	private Connection con;

	public Datenbank() {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		try {
			this.connect();
			this.createTables();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	private void createTables() throws SQLException {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 1);

		Statement stmt = this.con.createStatement();
		String createTable = "CREATE TABLE IF NOT EXISTS \"kontakte\" (" +
				"id INTEGER PRIMARY KEY AUTOINCREMENT NOT NULL, " +
				"vorname VARCHAR(50) NULL, " +
				"nachname VARCHAR(50) NULL, " +
				"strasse VARCHAR(50) NULL, " +
				"hnr VARCHAR(10) NULL, " +
				"plz VARCHAR(5) NULL, " +
				"ort VARCHAR(50) NULL, " +
				"telefon VARCHAR(30) UNIQUE NULL" +
				");";
		stmt.execute(createTable);
	}

	/**
	 * Verbindung zur Datenbank aufbauen
	 */
	private void connect() throws SQLException {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 1);

		String datenbankdatei = "c:\\temp\\telefonbuch.sqlite";

		this.con = DriverManager.getConnection("jdbc:sqlite:" + datenbankdatei);
	}

	public void addKontakt(Kontakt kontakt) {

		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 1);

		try {
			Statement stmt = this.con.createStatement();

			String checkKontakt = "SELECT id FROM kontakte WHERE telefon=\"" + kontakt.getId() + "\";";
			ResultSet checkResult = stmt.executeQuery(checkKontakt);

			int rows = 0;
			while (checkResult.next()) {
				rows++;
			}

			String insertKontakt;

			if (rows == 1) {
				new Fehler().debug("Updating contact", false);

				insertKontakt = "UPDATE kontakte SET " +
						"vorname=\"" + kontakt.getVorname() + "\", " +
						"nachname=\"" + kontakt.getNachname() + "\", " +
						"strasse=\"" + kontakt.getStrasse() + "\", " +
						"hnr=\"" + kontakt.getHausnummer() + "\", " +
						"plz=\"" + kontakt.getPlz() + "\", " +
						"ort=\"" + kontakt.getOrt() + "\", " +
						"telefon=\"" + kontakt.getTelefon() + "\" " +
						" WHERE telefon=\"" + kontakt.getId() + "\";";
			} else {
				new Fehler().debug("Insert new contact", false);

				insertKontakt = "INSERT INTO kontakte (vorname, nachname, strasse, hnr, plz, ort, telefon) VALUES (" +
						"\"" + kontakt.getVorname() + "\", " +
						"\"" + kontakt.getNachname() + "\", " +
						"\"" + kontakt.getStrasse() + "\", " +
						"\"" + kontakt.getHausnummer() + "\", " +
						"\"" + kontakt.getPlz() + "\", " +
						"\"" + kontakt.getOrt() + "\", " +
						"\"" + kontakt.getTelefon() + "\" " +
						");";
			}
			new Fehler().debug(insertKontakt, false);

			stmt.execute(insertKontakt);
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	public void deleteKontakt(String telefon) {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 2);

		try {
			Statement stmt = this.con.createStatement();

			String sql = "  DELETE FROM kontakte" +
					"       WHERE telefon=\"" + telefon + "\";";
			stmt.execute(sql);

		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	public Kontakt getKontakt(String telefon) {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		Kontakt kontakt = new Kontakt();
		String sql;

		try {
			Statement stmt = this.con.createStatement();

			if (telefon.equals("first")) {
				sql = "SELECT * " +
						"FROM kontakte " +
						"LIMIT 1;";
			} else {
				sql = "SELECT * " +
						"FROM kontakte " +
						"WHERE telefon=\"" + telefon + "\";";
			}
			ResultSet rs = stmt.executeQuery(sql);

			while (rs.next()) {
				if (rs.getString("telefon").equals(telefon) || telefon.equals("first")) {
					kontakt.setId(rs.getString("telefon"));
					kontakt.setVorname(rs.getString("vorname"));
					kontakt.setNachname(rs.getString("nachname"));
					kontakt.setStrasse(rs.getString("strasse"));
					kontakt.setHausnummer(rs.getString("hnr"));
					kontakt.setPlz(rs.getString("plz"));
					kontakt.setOrt(rs.getString("ort"));
					kontakt.setTelefon(rs.getString("telefon"));

					if (telefon.equals("first")) {
						break;
					}
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		return kontakt;
	}

	public String[] getNavi(String telefon) {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		String[] naviResult = new String[3];

		try {
			Statement stmt = this.con.createStatement();
			String sql = "SELECT\n" +
					"    CASE\n" +
					"        WHEN LAG(telefon) OVER (ORDER BY nachname) IS NULL THEN (\n" +
					"            SELECT telefon\n" +
					"            FROM kontakte\n" +
					"            ORDER BY nachname DESC\n" +
					"            LIMIT 1\n" +
					"        )\n" +
					"        ELSE LAG(telefon) OVER (ORDER BY nachname)\n" +
					"    END last,\n" +
					"    telefon AS current,\n" +
					"    CASE\n" +
					"        WHEN LEAD(telefon) OVER (ORDER BY nachname) IS NULL THEN (\n" +
					"            SELECT telefon\n" +
					"            FROM kontakte\n" +
					"            ORDER BY nachname ASC\n" +
					"            LIMIT 1\n" +
					"        )\n" +
					"        ELSE LEAD(telefon) OVER (ORDER BY nachname)\n" +
					"    END next\n" +
					"FROM kontakte\n" +
					"ORDER BY nachname ASC;";

			ResultSet rs = stmt.executeQuery(sql);

			while (rs.next()) {
				if (rs.getString("current").equals(telefon)) {
					naviResult[0] = rs.getString("last");
					naviResult[1] = rs.getString("current");
					naviResult[2] = rs.getString("next");
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}

		return naviResult;
	}

	public int countKontakte() {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 2);

		int intResult = 0;

		try {
			Statement stmt = this.con.createStatement();

			String sql = "  SELECT COUNT(*) AS count" +
					"       FROM kontakte;";
			ResultSet rs = stmt.executeQuery(sql);

			intResult = rs.getInt("count");

		} catch (SQLException e) {
			e.printStackTrace();
		}

		new Fehler().debug("Result: " + intResult, false);

		return intResult;
	}
}
